
module MenhirBasics = struct
  
  exception Error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | UIDENT of (
# 42 "src/algdt_parser_y.mly"
       (string)
# 15 "src/algdt_parser_y.ml"
  )
    | STAR
    | RPAREN
    | MINUSGREATER
    | LPAREN
    | LIDENT of (
# 43 "src/algdt_parser_y.mly"
       (string)
# 24 "src/algdt_parser_y.ml"
  )
    | EQUAL
    | EOF
    | DOT
    | COMMA
    | BAR
  
end

include MenhirBasics

# 1 "src/algdt_parser_y.mly"
  
(*
   AIFAD - Automated Induction of Functions over Algebraic Datatypes

   Author: Markus Mottl
   email:  markus.mottl@gmail.com
   WWW:    http://www.ocaml.info

   Copyright (C) 2002  Austrian Research Institute for Artificial Intelligence
   Copyright (C) 2003- Markus Mottl

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public License
   along with this library; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*)

open Utils
open Algdt_types

let make_prod_els prods prod = ProdEls (array_of_rev_list (prod :: prods))

# 68 "src/algdt_parser_y.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState00 : ('s, _menhir_box_data) _menhir_state
    (** State 00.
        Stack shape : .
        Start symbol: data. *)

  | MenhirState01 : (('s, 'r) _menhir_cell1_UIDENT, 'r) _menhir_state
    (** State 01.
        Stack shape : UIDENT.
        Start symbol: <undetermined>. *)

  | MenhirState03 : ((('s, 'r) _menhir_cell1_UIDENT, 'r) _menhir_cell1_LPAREN, 'r) _menhir_state
    (** State 03.
        Stack shape : UIDENT LPAREN.
        Start symbol: <undetermined>. *)

  | MenhirState04 : (((('s, 'r) _menhir_cell1_UIDENT, 'r) _menhir_cell1_LPAREN, 'r) _menhir_cell1_UIDENT, 'r) _menhir_state
    (** State 04.
        Stack shape : UIDENT LPAREN UIDENT.
        Start symbol: <undetermined>. *)

  | MenhirState08 : (('s, 'r) _menhir_cell1_LPAREN, 'r) _menhir_state
    (** State 08.
        Stack shape : LPAREN.
        Start symbol: <undetermined>. *)

  | MenhirState10 : ((('s, 'r) _menhir_cell1_LPAREN, 'r) _menhir_cell1_data_prods, 'r) _menhir_state
    (** State 10.
        Stack shape : LPAREN data_prods.
        Start symbol: <undetermined>. *)

  | MenhirState20 : ('s, _menhir_box_data_sample) _menhir_state
    (** State 20.
        Stack shape : .
        Start symbol: data_sample. *)

  | MenhirState24 : (('s, _menhir_box_data_sample) _menhir_cell1_data_el, _menhir_box_data_sample) _menhir_state
    (** State 24.
        Stack shape : data_el.
        Start symbol: data_sample. *)

  | MenhirState27 : ('s, _menhir_box_lhs_data) _menhir_state
    (** State 27.
        Stack shape : .
        Start symbol: lhs_data. *)

  | MenhirState30 : (('s, _menhir_box_lhs_data) _menhir_cell1_data_el, _menhir_box_lhs_data) _menhir_state
    (** State 30.
        Stack shape : data_el.
        Start symbol: lhs_data. *)

  | MenhirState34 : ('s, _menhir_box_rhs_data) _menhir_state
    (** State 34.
        Stack shape : .
        Start symbol: rhs_data. *)

  | MenhirState37 : (('s, _menhir_box_rhs_data) _menhir_cell1_data_el, _menhir_box_rhs_data) _menhir_state
    (** State 37.
        Stack shape : data_el.
        Start symbol: rhs_data. *)

  | MenhirState41 : ('s, _menhir_box_spec) _menhir_state
    (** State 41.
        Stack shape : .
        Start symbol: spec. *)

  | MenhirState43 : (('s, _menhir_box_spec) _menhir_cell1_LIDENT, _menhir_box_spec) _menhir_state
    (** State 43.
        Stack shape : LIDENT.
        Start symbol: spec. *)

  | MenhirState44 : (('s, _menhir_box_spec) _menhir_cell1_UIDENT, _menhir_box_spec) _menhir_state
    (** State 44.
        Stack shape : UIDENT.
        Start symbol: spec. *)

  | MenhirState45 : (('s, _menhir_box_spec) _menhir_cell1_LPAREN, _menhir_box_spec) _menhir_state
    (** State 45.
        Stack shape : LPAREN.
        Start symbol: spec. *)

  | MenhirState48 : ((('s, _menhir_box_spec) _menhir_cell1_LPAREN, _menhir_box_spec) _menhir_cell1_prods, _menhir_box_spec) _menhir_state
    (** State 48.
        Stack shape : LPAREN prods.
        Start symbol: spec. *)

  | MenhirState53 : ((('s, _menhir_box_spec) _menhir_cell1_LIDENT, _menhir_box_spec) _menhir_cell1_BAR, _menhir_box_spec) _menhir_state
    (** State 53.
        Stack shape : LIDENT BAR.
        Start symbol: spec. *)

  | MenhirState55 : (('s, _menhir_box_spec) _menhir_cell1_sums, _menhir_box_spec) _menhir_state
    (** State 55.
        Stack shape : sums.
        Start symbol: spec. *)

  | MenhirState63 : (('s, _menhir_box_spec) _menhir_cell1_type_defs, _menhir_box_spec) _menhir_state
    (** State 63.
        Stack shape : type_defs.
        Start symbol: spec. *)


and ('s, 'r) _menhir_cell1_data_el = 
  | MenhirCell1_data_el of 's * ('s, 'r) _menhir_state * (string Algdt_types.data)

and ('s, 'r) _menhir_cell1_data_prods = 
  | MenhirCell1_data_prods of 's * ('s, 'r) _menhir_state * (string Algdt_types.dsum Algdt_types.prod_el list)

and ('s, 'r) _menhir_cell1_prods = 
  | MenhirCell1_prods of 's * ('s, 'r) _menhir_state * (string Algdt_types.prod_el list)

and ('s, 'r) _menhir_cell1_sums = 
  | MenhirCell1_sums of 's * ('s, 'r) _menhir_state * ((string, string) Algdt_types.sum list)

and ('s, 'r) _menhir_cell1_type_defs = 
  | MenhirCell1_type_defs of 's * ('s, 'r) _menhir_state * ((string, string) Algdt_types.type_def list)

and ('s, 'r) _menhir_cell1_BAR = 
  | MenhirCell1_BAR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LIDENT = 
  | MenhirCell1_LIDENT of 's * ('s, 'r) _menhir_state * (
# 43 "src/algdt_parser_y.mly"
       (string)
# 194 "src/algdt_parser_y.ml"
)

and ('s, 'r) _menhir_cell1_LPAREN = 
  | MenhirCell1_LPAREN of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_UIDENT = 
  | MenhirCell1_UIDENT of 's * ('s, 'r) _menhir_state * (
# 42 "src/algdt_parser_y.mly"
       (string)
# 204 "src/algdt_parser_y.ml"
)

and _menhir_box_spec = 
  | MenhirBox_spec of ((string, string) Dune__exe__Algdt_types.type_defs) [@@unboxed]

and _menhir_box_rhs_data = 
  | MenhirBox_rhs_data of (string Algdt_types.data option) [@@unboxed]

and _menhir_box_lhs_data = 
  | MenhirBox_lhs_data of (string Algdt_types.data option) [@@unboxed]

and _menhir_box_data_sample = 
  | MenhirBox_data_sample of (string Algdt_types.data_sample option) [@@unboxed]

and _menhir_box_data = 
  | MenhirBox_data of (string Algdt_types.data option) [@@unboxed]

let _menhir_action_05 =
  fun _1 ->
    (
# 100 "src/algdt_parser_y.mly"
                ( Some _1 )
# 227 "src/algdt_parser_y.ml"
     : (string Algdt_types.data option))

let _menhir_action_06 =
  fun () ->
    (
# 101 "src/algdt_parser_y.mly"
        ( None )
# 235 "src/algdt_parser_y.ml"
     : (string Algdt_types.data option))

let _menhir_action_07 =
  fun _2 _3 ->
    (
# 124 "src/algdt_parser_y.mly"
                                  ( TpVal (DStrct (_2, _3)) )
# 243 "src/algdt_parser_y.ml"
     : (string Algdt_types.dsum Algdt_types.prod_el))

let _menhir_action_08 =
  fun _1 ->
    (
# 125 "src/algdt_parser_y.mly"
              ( _1 )
# 251 "src/algdt_parser_y.ml"
     : (string Algdt_types.dsum Algdt_types.prod_el))

let _menhir_action_09 =
  fun _1 _2 ->
    (
# 120 "src/algdt_parser_y.mly"
                    ( TpVal (DStrct (_1, _2)) )
# 259 "src/algdt_parser_y.ml"
     : (string Algdt_types.data))

let _menhir_action_10 =
  fun _1 ->
    (
# 121 "src/algdt_parser_y.mly"
              ( _1 )
# 267 "src/algdt_parser_y.ml"
     : (string Algdt_types.data))

let _menhir_action_11 =
  fun _2 _4 ->
    (
# 116 "src/algdt_parser_y.mly"
                                           ( make_prod_els _2 _4 )
# 275 "src/algdt_parser_y.ml"
     : (string Algdt_types.dsum Algdt_types.prod_el))

let _menhir_action_12 =
  fun _1 ->
    (
# 117 "src/algdt_parser_y.mly"
           ( TpVal (DAtom _1) )
# 283 "src/algdt_parser_y.ml"
     : (string Algdt_types.dsum Algdt_types.prod_el))

let _menhir_action_13 =
  fun _1 _3 ->
    (
# 128 "src/algdt_parser_y.mly"
                             ( _3 :: _1 )
# 291 "src/algdt_parser_y.ml"
     : (string Algdt_types.dsum Algdt_types.prod_el list))

let _menhir_action_14 =
  fun _1 ->
    (
# 129 "src/algdt_parser_y.mly"
            ( [_1] )
# 299 "src/algdt_parser_y.ml"
     : (string Algdt_types.dsum Algdt_types.prod_el list))

let _menhir_action_15 =
  fun _1 _3 ->
    (
# 104 "src/algdt_parser_y.mly"
                                     ( Some (_1, _3) )
# 307 "src/algdt_parser_y.ml"
     : (string Algdt_types.data_sample option))

let _menhir_action_16 =
  fun () ->
    (
# 105 "src/algdt_parser_y.mly"
        ( None )
# 315 "src/algdt_parser_y.ml"
     : (string Algdt_types.data_sample option))

let _menhir_action_17 =
  fun _1 ->
    (
# 108 "src/algdt_parser_y.mly"
         ( _1 )
# 323 "src/algdt_parser_y.ml"
     : (string Algdt_types.data option))

let _menhir_action_18 =
  fun _1 ->
    (
# 109 "src/algdt_parser_y.mly"
                                     ( Some _1 )
# 331 "src/algdt_parser_y.ml"
     : (string Algdt_types.data option))

let _menhir_action_19 =
  fun _1 ->
    (
# 77 "src/algdt_parser_y.mly"
           ( TpVal _1 )
# 339 "src/algdt_parser_y.ml"
     : (string Algdt_types.prod_el))

let _menhir_action_20 =
  fun _2 _4 ->
    (
# 78 "src/algdt_parser_y.mly"
                                     ( make_prod_els _2 _4 )
# 347 "src/algdt_parser_y.ml"
     : (string Algdt_types.prod_el))

let _menhir_action_21 =
  fun _1 ->
    (
# 81 "src/algdt_parser_y.mly"
            ( [_1] )
# 355 "src/algdt_parser_y.ml"
     : (string Algdt_types.prod_el list))

let _menhir_action_22 =
  fun _1 _3 ->
    (
# 82 "src/algdt_parser_y.mly"
                       ( _3 :: _1 )
# 363 "src/algdt_parser_y.ml"
     : (string Algdt_types.prod_el list))

let _menhir_action_23 =
  fun _1 ->
    (
# 73 "src/algdt_parser_y.mly"
            ( Prod _1 )
# 371 "src/algdt_parser_y.ml"
     : ((string Algdt_types.prod_el, (string, string) Algdt_types.sum array)
  Algdt_types.rhs))

let _menhir_action_24 =
  fun _1 ->
    (
# 74 "src/algdt_parser_y.mly"
        ( Sums (array_of_rev_list _1) )
# 380 "src/algdt_parser_y.ml"
     : ((string Algdt_types.prod_el, (string, string) Algdt_types.sum array)
  Algdt_types.rhs))

let _menhir_action_25 =
  fun _1 ->
    (
# 112 "src/algdt_parser_y.mly"
         ( _1 )
# 389 "src/algdt_parser_y.ml"
     : (string Algdt_types.data option))

let _menhir_action_26 =
  fun _3 ->
    (
# 113 "src/algdt_parser_y.mly"
                                     ( Some _3 )
# 397 "src/algdt_parser_y.ml"
     : (string Algdt_types.data option))

let _menhir_action_27 =
  fun _1 ->
    (
# 64 "src/algdt_parser_y.mly"
                     ( array_of_rev_list _1 )
# 405 "src/algdt_parser_y.ml"
     : ((string, string) Dune__exe__Algdt_types.type_defs))

let _menhir_action_28 =
  fun _1 ->
    (
# 85 "src/algdt_parser_y.mly"
         ( _1 )
# 413 "src/algdt_parser_y.ml"
     : ((string, string) Algdt_types.sum list))

let _menhir_action_29 =
  fun _2 ->
    (
# 86 "src/algdt_parser_y.mly"
             ( _2 )
# 421 "src/algdt_parser_y.ml"
     : ((string, string) Algdt_types.sum list))

let _menhir_action_30 =
  fun _1 ->
    (
# 93 "src/algdt_parser_y.mly"
           ( Atom _1 )
# 429 "src/algdt_parser_y.ml"
     : ((string, string) Algdt_types.sum))

let _menhir_action_31 =
  fun _1 _2 ->
    (
# 94 "src/algdt_parser_y.mly"
                   ( Strct (_1, _2) )
# 437 "src/algdt_parser_y.ml"
     : ((string, string) Algdt_types.sum))

let _menhir_action_32 =
  fun _1 ->
    (
# 89 "src/algdt_parser_y.mly"
           ( [_1] )
# 445 "src/algdt_parser_y.ml"
     : ((string, string) Algdt_types.sum list))

let _menhir_action_33 =
  fun _1 _3 ->
    (
# 90 "src/algdt_parser_y.mly"
                    ( _3 :: _1 )
# 453 "src/algdt_parser_y.ml"
     : ((string, string) Algdt_types.sum list))

let _menhir_action_34 =
  fun _1 _3 ->
    (
# 70 "src/algdt_parser_y.mly"
                                ( _1, _3 )
# 461 "src/algdt_parser_y.ml"
     : ((string, string) Algdt_types.type_def))

let _menhir_action_35 =
  fun _1 ->
    (
# 67 "src/algdt_parser_y.mly"
             ( [_1] )
# 469 "src/algdt_parser_y.ml"
     : ((string, string) Algdt_types.type_def list))

let _menhir_action_36 =
  fun _1 _2 ->
    (
# 68 "src/algdt_parser_y.mly"
                       ( _2 :: _1 )
# 477 "src/algdt_parser_y.ml"
     : ((string, string) Algdt_types.type_def list))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | BAR ->
        "BAR"
    | COMMA ->
        "COMMA"
    | DOT ->
        "DOT"
    | EOF ->
        "EOF"
    | EQUAL ->
        "EQUAL"
    | LIDENT _ ->
        "LIDENT"
    | LPAREN ->
        "LPAREN"
    | MINUSGREATER ->
        "MINUSGREATER"
    | RPAREN ->
        "RPAREN"
    | STAR ->
        "STAR"
    | UIDENT _ ->
        "UIDENT"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_goto_rhs_data : type  ttv_stack. ttv_stack -> _ -> _menhir_box_rhs_data =
    fun _menhir_stack _v ->
      MenhirBox_rhs_data _v
  
  let _menhir_run_38 : type  ttv_stack. (ttv_stack, _menhir_box_rhs_data) _menhir_cell1_data_el -> _ -> _ -> _menhir_box_rhs_data =
    fun _menhir_stack _v _tok ->
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let MenhirCell1_data_el (_menhir_stack, _, _) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_26 _3 in
          _menhir_goto_rhs_data _menhir_stack _v
      | _ ->
          _eRR ()
  
  let _menhir_run_40 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_rhs_data =
    fun _menhir_stack _v ->
      let _1 = _v in
      let _v = _menhir_action_25 _1 in
      _menhir_goto_rhs_data _menhir_stack _v
  
  let _menhir_goto_lhs_data : type  ttv_stack. ttv_stack -> _ -> _menhir_box_lhs_data =
    fun _menhir_stack _v ->
      MenhirBox_lhs_data _v
  
  let _menhir_run_33 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_lhs_data =
    fun _menhir_stack _v ->
      let _1 = _v in
      let _v = _menhir_action_17 _1 in
      _menhir_goto_lhs_data _menhir_stack _v
  
  let _menhir_run_19 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_data =
    fun _menhir_stack _v ->
      MenhirBox_data _v
  
  let _menhir_goto_data : type  ttv_stack ttv_result. ttv_stack -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState34 ->
          _menhir_run_40 _menhir_stack _v
      | MenhirState27 ->
          _menhir_run_33 _menhir_stack _v
      | MenhirState00 ->
          _menhir_run_19 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  let _menhir_run_18 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_data_el -> ttv_result =
    fun _menhir_stack ->
      let MenhirCell1_data_el (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _v = _menhir_action_05 _1 in
      _menhir_goto_data _menhir_stack _v _menhir_s
  
  let _menhir_run_31 : type  ttv_stack. (ttv_stack, _menhir_box_lhs_data) _menhir_cell1_data_el -> _ -> _menhir_box_lhs_data =
    fun _menhir_stack _tok ->
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let MenhirCell1_data_el (_menhir_stack, _, _1) = _menhir_stack in
          let _v = _menhir_action_18 _1 in
          _menhir_goto_lhs_data _menhir_stack _v
      | _ ->
          _eRR ()
  
  let _menhir_goto_data_sample : type  ttv_stack. ttv_stack -> _ -> _menhir_box_data_sample =
    fun _menhir_stack _v ->
      MenhirBox_data_sample _v
  
  let _menhir_run_25 : type  ttv_stack. (ttv_stack, _menhir_box_data_sample) _menhir_cell1_data_el -> _ -> _ -> _menhir_box_data_sample =
    fun _menhir_stack _v _tok ->
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let MenhirCell1_data_el (_menhir_stack, _, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_15 _1 _3 in
          _menhir_goto_data_sample _menhir_stack _v
      | _ ->
          _eRR ()
  
  let _menhir_run_17 : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_data) _menhir_state -> _ -> _menhir_box_data =
    fun _menhir_stack _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_data_el (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | DOT ->
          _menhir_run_18 _menhir_stack
      | _ ->
          _eRR ()
  
  let rec _menhir_run_01 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | UIDENT _v_0 ->
          let _menhir_stack = MenhirCell1_UIDENT (_menhir_stack, _menhir_s, _v) in
          _menhir_run_02 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState01
      | LPAREN ->
          let _menhir_stack = MenhirCell1_UIDENT (_menhir_stack, _menhir_s, _v) in
          _menhir_run_03 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState01
      | COMMA | DOT | MINUSGREATER | RPAREN ->
          let _1 = _v in
          let _v = _menhir_action_12 _1 in
          _menhir_goto_data_part _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_02 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UIDENT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_12 _1 in
      _menhir_goto_data_part _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_data_part : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState37 ->
          _menhir_run_11 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState34 ->
          _menhir_run_11 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState30 ->
          _menhir_run_11 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState27 ->
          _menhir_run_11 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState24 ->
          _menhir_run_11 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState20 ->
          _menhir_run_11 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState00 ->
          _menhir_run_11 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState03 ->
          _menhir_run_11 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState08 ->
          _menhir_run_11 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState10 ->
          _menhir_run_11 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState01 ->
          _menhir_run_05 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState04 ->
          _menhir_run_05 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_11 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_10 _1 in
      _menhir_goto_data_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_data_el : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState37 ->
          _menhir_run_38 _menhir_stack _v _tok
      | MenhirState34 ->
          _menhir_run_36 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState30 ->
          _menhir_run_31 _menhir_stack _tok
      | MenhirState27 ->
          _menhir_run_29 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState24 ->
          _menhir_run_25 _menhir_stack _v _tok
      | MenhirState20 ->
          _menhir_run_23 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState00 ->
          _menhir_run_17 _menhir_stack _v _menhir_s _tok
      | MenhirState03 ->
          _menhir_run_14 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState08 ->
          _menhir_run_14 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState10 ->
          _menhir_run_12 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_36 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_rhs_data) _menhir_state -> _ -> _menhir_box_rhs_data =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_data_el (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | MINUSGREATER ->
          let _menhir_s = MenhirState37 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UIDENT _v ->
              _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAREN ->
              _menhir_run_08 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | DOT ->
          _menhir_run_18 _menhir_stack
      | _ ->
          _eRR ()
  
  and _menhir_run_08 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAREN (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState08 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | UIDENT _v ->
          _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAREN ->
          _menhir_run_08 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_29 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_lhs_data) _menhir_state -> _ -> _menhir_box_lhs_data =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_data_el (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | MINUSGREATER ->
          let _menhir_s = MenhirState30 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UIDENT _v ->
              _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAREN ->
              _menhir_run_08 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | DOT ->
          _menhir_run_18 _menhir_stack
      | _ ->
          _eRR ()
  
  and _menhir_run_23 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_data_sample) _menhir_state -> _ -> _menhir_box_data_sample =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_data_el (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | MINUSGREATER ->
          let _menhir_s = MenhirState24 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UIDENT _v ->
              _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAREN ->
              _menhir_run_08 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_14 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAREN as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_14 _1 in
      _menhir_goto_data_prods _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_data_prods : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAREN as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_data_prods (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_s = MenhirState10 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UIDENT _v ->
              _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAREN ->
              _menhir_run_08 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_12 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAREN, ttv_result) _menhir_cell1_data_prods -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAREN ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_data_prods (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LPAREN (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_11 _2 _4 in
          _menhir_goto_data_part _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | COMMA ->
          let MenhirCell1_data_prods (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_13 _1 _3 in
          _menhir_goto_data_prods _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_05 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UIDENT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_08 _1 in
      _menhir_goto_data_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_data_arg : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UIDENT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState01 ->
          _menhir_run_15 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState04 ->
          _menhir_run_06 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_15 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UIDENT -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_UIDENT (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_09 _1 _2 in
      _menhir_goto_data_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_06 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_UIDENT, ttv_result) _menhir_cell1_LPAREN, ttv_result) _menhir_cell1_UIDENT -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAREN ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_UIDENT (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LPAREN (_menhir_stack, _menhir_s) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_07 _2 _3 in
          _menhir_goto_data_arg _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | COMMA ->
          let MenhirCell1_UIDENT (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_09 _1 _2 in
          _menhir_goto_data_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_03 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_UIDENT as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAREN (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | UIDENT _v ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UIDENT _v_0 ->
              let _menhir_stack = MenhirCell1_UIDENT (_menhir_stack, MenhirState03, _v) in
              _menhir_run_02 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState04
          | LPAREN ->
              let _menhir_stack = MenhirCell1_UIDENT (_menhir_stack, MenhirState03, _v) in
              _menhir_run_03 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState04
          | COMMA ->
              let _v =
                let _1 = _v in
                _menhir_action_12 _1
              in
              _menhir_run_11 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState03 _tok
          | _ ->
              _eRR ())
      | LPAREN ->
          _menhir_run_08 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState03
      | _ ->
          _eRR ()
  
  let _menhir_run_16 : type  ttv_stack ttv_result. ttv_stack -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_s ->
      let _v = _menhir_action_06 () in
      _menhir_goto_data _menhir_stack _v _menhir_s
  
  let _menhir_run_00 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_data =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState00 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | UIDENT _v ->
          _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAREN ->
          _menhir_run_08 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EOF ->
          _menhir_run_16 _menhir_stack _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_run_20 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_data_sample =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | UIDENT _v ->
          _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState20
      | LPAREN ->
          _menhir_run_08 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState20
      | EOF ->
          let _v = _menhir_action_16 () in
          _menhir_goto_data_sample _menhir_stack _v
      | _ ->
          _eRR ()
  
  let _menhir_run_27 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_lhs_data =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState27 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | UIDENT _v ->
          _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAREN ->
          _menhir_run_08 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EOF ->
          _menhir_run_16 _menhir_stack _menhir_s
      | _ ->
          _eRR ()
  
  let _menhir_run_34 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_rhs_data =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState34 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | UIDENT _v ->
          _menhir_run_01 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | LPAREN ->
          _menhir_run_08 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EOF ->
          _menhir_run_16 _menhir_stack _menhir_s
      | _ ->
          _eRR ()
  
  let rec _menhir_run_42 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_spec) _menhir_state -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _menhir_stack = MenhirCell1_LIDENT (_menhir_stack, _menhir_s, _v) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | EQUAL ->
          let _menhir_s = MenhirState43 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | UIDENT _v ->
              _menhir_run_44 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | LPAREN ->
              _menhir_run_45 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LIDENT _v ->
              _menhir_run_46 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | BAR ->
              let _menhir_stack = MenhirCell1_BAR (_menhir_stack, _menhir_s) in
              let _menhir_s = MenhirState53 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | UIDENT _v ->
                  _menhir_run_44 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | _ ->
                  _eRR ())
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_44 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_spec) _menhir_state -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAREN ->
          let _menhir_stack = MenhirCell1_UIDENT (_menhir_stack, _menhir_s, _v) in
          _menhir_run_45 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState44
      | LIDENT _v_0 ->
          let _menhir_stack = MenhirCell1_UIDENT (_menhir_stack, _menhir_s, _v) in
          _menhir_run_46 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState44
      | BAR | DOT ->
          let _1 = _v in
          let _v = _menhir_action_30 _1 in
          _menhir_goto_sum_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_45 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_spec) _menhir_state -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      let _menhir_stack = MenhirCell1_LPAREN (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState45 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAREN ->
          _menhir_run_45 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LIDENT _v ->
          _menhir_run_46 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_run_46 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_spec) _menhir_state -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      let _tok = _menhir_lexer _menhir_lexbuf in
      let _1 = _v in
      let _v = _menhir_action_19 _1 in
      _menhir_goto_prod_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_prod_el : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_spec) _menhir_state -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState43 ->
          _menhir_run_62 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState44 ->
          _menhir_run_52 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState45 ->
          _menhir_run_51 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState48 ->
          _menhir_run_49 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_62 : type  ttv_stack. (ttv_stack, _menhir_box_spec) _menhir_cell1_LIDENT -> _ -> _ -> _ -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_23 _1 in
      _menhir_goto_rhs _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_goto_rhs : type  ttv_stack. (ttv_stack, _menhir_box_spec) _menhir_cell1_LIDENT -> _ -> _ -> _ -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | DOT ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LIDENT (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_34 _1 _3 in
          _menhir_goto_type_def _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  and _menhir_goto_type_def : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_spec) _menhir_state -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState41 ->
          _menhir_run_66 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState63 ->
          _menhir_run_65 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_66 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_spec) _menhir_state -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_35 _1 in
      _menhir_goto_type_defs _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_type_defs : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_spec) _menhir_state -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | LIDENT _v_0 ->
          let _menhir_stack = MenhirCell1_type_defs (_menhir_stack, _menhir_s, _v) in
          _menhir_run_42 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState63
      | EOF ->
          let _1 = _v in
          let _v = _menhir_action_27 _1 in
          MenhirBox_spec _v
      | _ ->
          _eRR ()
  
  and _menhir_run_65 : type  ttv_stack. (ttv_stack, _menhir_box_spec) _menhir_cell1_type_defs -> _ -> _ -> _ -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_type_defs (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_36 _1 _2 in
      _menhir_goto_type_defs _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_52 : type  ttv_stack. (ttv_stack, _menhir_box_spec) _menhir_cell1_UIDENT -> _ -> _ -> _ -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_UIDENT (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _2 = _v in
      let _v = _menhir_action_31 _1 _2 in
      _menhir_goto_sum_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_sum_el : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_spec) _menhir_state -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState43 ->
          _menhir_run_57 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState53 ->
          _menhir_run_57 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState55 ->
          _menhir_run_56 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_57 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_spec) _menhir_state -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_32 _1 in
      _menhir_goto_sums _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_sums : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_spec) _menhir_state -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState43 ->
          _menhir_run_58 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState53 ->
          _menhir_run_54 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_58 : type  ttv_stack. ((ttv_stack, _menhir_box_spec) _menhir_cell1_LIDENT as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_spec) _menhir_state -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | BAR ->
          let _menhir_stack = MenhirCell1_sums (_menhir_stack, _menhir_s, _v) in
          _menhir_run_55 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let _1 = _v in
          let _v = _menhir_action_28 _1 in
          _menhir_goto_sum _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_55 : type  ttv_stack. (ttv_stack, _menhir_box_spec) _menhir_cell1_sums -> _ -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState55 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | UIDENT _v ->
          _menhir_run_44 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
  and _menhir_goto_sum : type  ttv_stack. (ttv_stack, _menhir_box_spec) _menhir_cell1_LIDENT -> _ -> _ -> _ -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let _1 = _v in
      let _v = _menhir_action_24 _1 in
      _menhir_goto_rhs _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_54 : type  ttv_stack. (((ttv_stack, _menhir_box_spec) _menhir_cell1_LIDENT, _menhir_box_spec) _menhir_cell1_BAR as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_spec) _menhir_state -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match (_tok : MenhirBasics.token) with
      | BAR ->
          let _menhir_stack = MenhirCell1_sums (_menhir_stack, _menhir_s, _v) in
          _menhir_run_55 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOT ->
          let MenhirCell1_BAR (_menhir_stack, _) = _menhir_stack in
          let _2 = _v in
          let _v = _menhir_action_29 _2 in
          _menhir_goto_sum _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _eRR ()
  
  and _menhir_run_56 : type  ttv_stack. (ttv_stack, _menhir_box_spec) _menhir_cell1_sums -> _ -> _ -> _ -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      let MenhirCell1_sums (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      let _3 = _v in
      let _v = _menhir_action_33 _1 _3 in
      _menhir_goto_sums _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_51 : type  ttv_stack. ((ttv_stack, _menhir_box_spec) _menhir_cell1_LPAREN as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_spec) _menhir_state -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _1 = _v in
      let _v = _menhir_action_21 _1 in
      _menhir_goto_prods _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_prods : type  ttv_stack. ((ttv_stack, _menhir_box_spec) _menhir_cell1_LPAREN as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_spec) _menhir_state -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      let _menhir_stack = MenhirCell1_prods (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_s = MenhirState48 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LPAREN ->
              _menhir_run_45 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LIDENT _v ->
              _menhir_run_46 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _eRR ())
      | _ ->
          _eRR ()
  
  and _menhir_run_49 : type  ttv_stack. ((ttv_stack, _menhir_box_spec) _menhir_cell1_LPAREN, _menhir_box_spec) _menhir_cell1_prods -> _ -> _ -> _ -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      match (_tok : MenhirBasics.token) with
      | RPAREN ->
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_prods (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LPAREN (_menhir_stack, _menhir_s) = _menhir_stack in
          let _4 = _v in
          let _v = _menhir_action_20 _2 _4 in
          _menhir_goto_prod_el _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | STAR ->
          let MenhirCell1_prods (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          let _3 = _v in
          let _v = _menhir_action_22 _1 _3 in
          _menhir_goto_prods _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _eRR ()
  
  let _menhir_run_41 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      let _menhir_s = MenhirState41 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LIDENT _v ->
          _menhir_run_42 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _eRR ()
  
end

let spec =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_spec v = _menhir_run_41 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let rhs_data =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_rhs_data v = _menhir_run_34 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let lhs_data =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_lhs_data v = _menhir_run_27 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let data_sample =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_data_sample v = _menhir_run_20 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let data =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_data v = _menhir_run_00 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v
